function barscroll(y2d,tax,fignum)

if ~exist('fignum','var')
    if exist('tax','var') && length(tax) == 1
        fignum = tax;
        x2 = 1:length(y2d);
    elseif exist('tax','var')
        x2=tax;
    else
        x2 = 1:length(y2d);
    end
else
    x2 = tax;
end


if ~isreal(y2d{2})
    for k = 1: length(y2d)
    y2d{k}=real(y2d{k});
    end
    fprintf('Barscroll: Complex valued matrices given, using real part only.\n')
    
end

if exist('fignum','var')
    figure(fignum)
else
    figure
end
clf

bar3(y2d{1});
lims=[0 1];

for ii = 1 : length(y2d)
    if max(max(abs(y2d{ii}))) > lims(2)
        lims(2)=ceil(max(max(abs(y2d{ii}))));
    end
    if min(min(y2d{ii}))<0
        lims(1) = floor(min(min(abs(y2d{ii}))));
    end
    setappdata(gca,['dta' num2str(ii)],y2d{ii});
end


setappdata(gca,'lims',lims)
set(gca,'ZLim',getappdata(gca,'lims'));
setappdata(gca,'view',get(gca,'View'))

%%
setappdata(gca,'x2',x2);
% get handles and set figure props
fh = gcf;
ah = gca;

% This avoids flickering when updating the axis
set(fh,'doublebuffer','on');

% Generate constants for use in uicontrol initialization
pos=get(ah,'position');

% y text
ytext.pos = [pos(1)+pos(3)+0.005 pos(2) 0.06 0.05];
ytext.h = uicontrol(fh,'style','text', ...
    'units','normalized','position',ytext.pos,'String',num2str(x2(1)), ...
    'BackgroundColor',get(fh,'color'));
setappdata(gca,'ytext',ytext.h);

% yslide
yslide.pos=[pos(1)+pos(3)+0.02 pos(2)+0.1 0.03 pos(4)-0.2];
yslide.min = 1;
yslide.npts = 1000; % axis window dx by number of points
yslide.max = length(x2); % allows for overscaling
yslide.steps = length(x2)-1;


yslide.h=uicontrol(fh,'style','slider',...
    'units','normalized','position',yslide.pos,...
    'callback',@scroller,'min',yslide.min,'max',yslide.max,'SliderStep',[1 1]./yslide.steps,'value',1);

try  % R2014a and newer
    addlistener(yslide.h,'ContinuousValueChange',@scroller);
catch % R2013b and older
    addlistener(yslide.h,'ActionEvent',yslide.call_fun);
end

roter = rotate3d;
roter.ActionPostCallback = @rotatecallback;

setappdata(gca,'yslide',yslide.h);
setappdata(gca,'roter',roter.ActionPostCallback);

end

function rotatecallback(obj,evd)
newView = round(evd.Axes.View);
setappdata(gca,'view',newView);

end

function scroller(obj,evd)
bar3(getappdata(gca,['dta' num2str(floor(get(getappdata(gca,'yslide'),'value')))]));
set(gca,'ZLim',getappdata(gca,'lims'));
set(gca,'View',getappdata(gca,'view'));

set(getappdata(gca,'ytext'),'String',num2str(subsref(getappdata(gca,'x2'),struct('type','()','subs',{{(floor(get(getappdata(gca,'yslide'),'value')))}}))));
end