clear all; close all

% rectangular pulse
rectangular.tp = 10;    % pulse length in ns
rectangular.frq = 1;    % microwave freqency in GHz
rectangular.nu1 = 50;   % pulse amplitude in MHz, alternatively
% rectangular.beta = pi;  % alternative to nu1
rectangular.t_rise=0;   % rise time in ns
rectangular.type={'rectangular'};   % type of pulse

options.plot_domain = 'both';       % option for plotting
rectangular = triple(rectangular,options);  % processing building

plot_pulses(rectangular,options)    % plotting


% linear chirp pulse
chirp.tp = 100;
chirp.frq = [0.8 1.2];     % microwave frequency, sweeps from 0.8 to 1.2 GHz
chirp.Q = 5;               % critical adiabaticity of pulse
chirp.t_rise = 20;         
chirp.type = {'chirp'};

chirp = triple(chirp,options);
plot_pulses(chirp,options)

% hyperbolic secant pulse
HS.tp = 100;
HS.nu1 = 10;
HS.HSbeta = 10;    % apodization parameter
HS.HSorder = 2;    % order of HS pulse
HS.frq = [0.8 1.2];
HS.type = {'HS'};

HS = triple(HS,options);
plot_pulses(HS,options)

% WURST pulse
wurst.tp = 100;
wurst.nu1 = 30;
wurst.frq = [0.8 1.2];
wurst.type = {'WURST'};
wurst.WURSTN = 10;    % steepness of pulse, WURST-10

wurst = triple(wurst,options);
plot_pulses(wurst,options)